
/**
 * It's simply a tree.  Nothing fancy.  There's a rootnode, a mutator method, and a method
 * to find the level of the given node.
 * 
 * @author Mark Brown
 * @course AI
 * @version January 27, 2004 - Project 1
 */
public class Tree
{
    /*** Instance Variables ***/
    public TreeNode rootNode;
    
    /*** Constructor ***/
    public Tree()
    {
        rootNode = null;
    }
    
    public Tree(TreeNode newNode)
    {
        rootNode = newNode;
    }
    
    /*** Instance Methods ***/
    /*public void startTree(TreeNode newNode)
    {
        rootNode = newNode;
    }*/
    
    public int findLevel(TreeNode newNode)
    {
        int level = 0;
        TreeNode temp = newNode.plink;
        while (temp != null)
        {
            temp = temp.plink;
            level++;
        }
        return level;
    }
    
    public TreeNode findBottomLevel(int bottomLevel)
    {
        TreeNode newNode = rootNode;
        int level = 0;
        for (int i = 0; i < 24; i++)
        {
            while (newNode.links[i] != null)
            {
                newNode = newNode.links[0];
                level++;
            }
            if (level == bottomLevel)
            {
                return newNode;
            }
            else
            {
                newNode = newNode.plink;
                level--;
            }
        }
        
        System.out.println("Couldn't find the bottom of the tree.");
        return null;
    }
}
